package com.FranckBarbier.Java._Pedagogical_RSA;

public class Pedagogical_RSA_encryptor {

    private long _message = 0L, _n = 0L, _d;

    public Pedagogical_RSA_encryptor(char[] message) throws Exception {
        if (message.length > 8) {
            throw new Exception("Pedagogical_RSA_encryptor: Messages are limited to 64 bits"); // 'long' uses a 64-bit format in Java
        }
        /* long powersOfTwo = 0x0000000000000001L;
         for(int i = message.length;i > 0;i--) { // Caution: order of characters in message
         _message += message[i - 1] * powersOfTwo;
         powersOfTwo *= (2L * 2L * 2L * 2L * 2L * 2L * 2L * 2L);
         } */
        for (int i = 0; i < message.length; i++) {
            if (i > 0) {
                _message <<= 8;
            }
            _message += message[i];
        }
    }

    public void encrypt(long n, Euclid euclid) throws Exception {
        if (_n != 0L) {
            return;
        }
        _n = n; // '_message < n'!
        long[] solutions = euclid.solver(1L);
        if (solutions.length != 1) {
            _n = 0L; // For next round
            throw new Exception("Pedagogical_RSA_encryptor: No encryption");
        }
        _d = solutions[0];
        _message = Euclid.Exponentiation(_message, _n, Euclid.toBitSet(euclid.a()));
    }

    public void decrypt() {
        _message = Euclid.Exponentiation(_message, _n, Euclid.toBitSet(_d));
        _n = 0L; // For next round
    }

    public String message() {
        return Long.toBinaryString(_message);
    }
}
