package com.FranckBarbier.Java._Pedagogical_RSA;

import java.security.*;
import java.security.interfaces.*;

public class Pedagogical_RSA_using_Security {

    private java.math.BigInteger _message;
    private RSAPublicKey _public_key;
    private RSAPrivateKey _private_key;

    Pedagogical_RSA_using_Security(String message) throws NoSuchAlgorithmException {
        if (message == null) {
            throw new RuntimeException("Pedagogical_RSA_using_Security: No way...");
        }
        _message = new java.math.BigInteger(message.getBytes());
        //  'KeyPairGenerator' object instantiation that creates a public/private pair
        KeyPairGenerator keyPairGenenerator = KeyPairGenerator.getInstance("RSA");
        // Pair initialization with key size (in bits) from 512 using a random number
        keyPairGenenerator.initialize(1024, new SecureRandom());
        _public_key = (RSAPublicKey) keyPairGenenerator.generateKeyPair().getPublic();
        _private_key = (RSAPrivateKey) keyPairGenenerator.generateKeyPair().getPrivate();
    }

    void encrypt() {
        _message = _message.modPow(_public_key.getPublicExponent(), _public_key.getModulus());
    }

    void decrypt() {
        _message = _message.modPow(_private_key.getPrivateExponent(), _private_key.getModulus());
    }

    public String message() {
        return new String(_message.toByteArray());
    }

    public static void main(String[] args) {
        Pedagogical_RSA_using_Security p_rsa = null;
        try {
            p_rsa = new Pedagogical_RSA_using_Security("Franck");
        } catch (NoSuchAlgorithmException nsae) {
            nsae.printStackTrace();
            System.exit(1);
        }
        System.out.println("message: " + p_rsa.message());
        p_rsa.encrypt();
        System.out.println("message: " + p_rsa.message());
        p_rsa.decrypt();
        System.out.println("message: " + p_rsa.message());
    }
}
